pub mod Range_ {
    use super::*;
    use crate::module_1bb7938a::String_::fromCharCode;
    use crate::module_1bb7938a::String_::string;
    use crate::module_2a6d00db::Util_::compare;
    use crate::module_410a2b29::Interfaces_::System::Collections::Generic::IEnumerable_1;
    use crate::module_abc180be::Native_::getZero;
    use crate::module_abc180be::Native_::Func1;
    use crate::module_abc180be::Native_::Lrc;
    use crate::module_cee46a38::Seq_::unfold;
    pub fn rangeNumeric<T: PartialOrd + Default + core::ops::Add<Output = T> + Clone + 'static>(
        start: T,
        step: T,
        stop: T,
    ) -> Lrc<dyn IEnumerable_1<T>> {
        let stepComparedWithZero: i32 = compare(step.clone(), getZero::<T>());
        if stepComparedWithZero == 0i32 {
            panic!("{}", string("The step of a range cannot be zero"));
        }
        {
            let stepFn = Func1::new({
                let step = step.clone();
                let stepComparedWithZero = stepComparedWithZero.clone();
                let stop = stop.clone();
                move |x: T| {
                    let comparedWithLast: i32 = compare(x.clone(), stop.clone());
                    if if if stepComparedWithZero > 0i32 {
                        comparedWithLast <= 0i32
                    } else {
                        false
                    } {
                        true
                    } else {
                        if stepComparedWithZero < 0i32 {
                            comparedWithLast >= 0i32
                        } else {
                            false
                        }
                    } {
                        Some(Lrc::new((x.clone(), x.clone() + step.clone())))
                    } else {
                        None::<Lrc<(T, T)>>
                    }
                }
            });
            unfold(stepFn, start)
        }
    }
    pub fn rangeChar(start: char, stop: char) -> Lrc<dyn IEnumerable_1<char>> {
        let stepFn = Func1::new({
            let stop = stop.clone();
            move |c: u32| {
                if c <= stop as u32 {
                    Some(Lrc::new((fromCharCode(c), c + 1u32)))
                } else {
                    None::<Lrc<(char, u32)>>
                }
            }
        });
        unfold(stepFn, start as u32)
    }
}
