import { BigInteger_op_Inequality_56F059C0, BigInteger_op_Equality_56F059C0, BigInteger_op_GreaterThanOrEqual_56F059C0, BigInteger_op_GreaterThan_56F059C0, BigInteger_op_LessThanOrEqual_56F059C0, BigInteger_op_LessThan_56F059C0, BigInteger_op_ExclusiveOr_56F059C0, BigInteger_op_BitwiseOr_56F059C0, BigInteger_op_BitwiseAnd_56F059C0, BigInteger_op_LeftShift_62E082A2, BigInteger_op_RightShift_62E082A2, BigInteger_op_UnaryPlus_Z665282C2, BigInteger_op_UnaryNegation_Z665282C2, BigInteger_op_Modulus_56F059C0, BigInteger_op_Division_56F059C0, BigInteger_op_Multiply_56F059C0, BigInteger_op_Subtraction_56F059C0, BigInteger_op_Addition_56F059C0, BigInteger__get_IsOne, BigInteger__get_IsZero, BigInteger__get_Sign, BigInteger__get_ToDecimal, BigInteger__get_ToDouble, BigInteger__get_ToSingle, BigInteger__get_ToUInt64, BigInteger__get_ToInt64, BigInteger__get_ToUInt32, BigInteger__get_ToInt32, BigInteger__get_ToUInt16, BigInteger__get_ToInt16, BigInteger__get_ToByte, BigInteger__get_ToSByte, BigInteger_$ctor_Z524259A4, BigInteger_$ctor_Z524259C1, BigInteger_get_Two, BigInteger_get_One, BigInteger_get_Zero, BigInteger_Abs_Z665282C2, BigInteger_Pow_62E082A2, BigInteger_GreatestCommonDivisor_56F059C0, BigInteger_DivRem_56F059C0, BigInteger_Parse_Z721C83C5, BigInteger } from "./BigInt/z.js";
import { toString as toString_1, FSharpRef } from "./Types.js";
import { float64, float32, uint32, uint16, int16, uint8, int8, int32 } from "./Int32.js";
import { uint64, fromInteger, int64 } from "./Long.js";
import { decimal } from "./Decimal.js";
import { comparePrimitives, min, compare as compare_1, equals as equals_1, safeHash } from "./Util.js";
import { fill, reverse, find } from "./Array.js";
import { fold, empty, ofArrayWithTail, cons, toArray, head, FSharpList, skipWhile } from "./List.js";

export function isBigInt(x: any): boolean {
    return x instanceof BigInteger;
}

export function tryParse(str: string, res: FSharpRef<BigInteger>): boolean {
    try {
        res.contents = BigInteger_Parse_Z721C83C5(str);
        return true;
    }
    catch (matchValue: any) {
        return false;
    }
}

export function divRem(x: BigInteger, y: BigInteger, remainder: FSharpRef<BigInteger>): BigInteger {
    const patternInput: [BigInteger, BigInteger] = BigInteger_DivRem_56F059C0(x, y);
    remainder.contents = patternInput[1];
    return patternInput[0];
}

export function parse(arg: string): BigInteger {
    return BigInteger_Parse_Z721C83C5(arg);
}

export function greatestCommonDivisor(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_GreatestCommonDivisor_56F059C0(arg, arg_1);
}

export function pow(arg: BigInteger, arg_1: int32): BigInteger {
    return BigInteger_Pow_62E082A2(arg, arg_1);
}

export function abs(arg: BigInteger): BigInteger {
    return BigInteger_Abs_Z665282C2(arg);
}

export const zero = BigInteger_get_Zero();

export const one = BigInteger_get_One();

export const two = BigInteger_get_Two();

export function fromString(s: string): BigInteger {
    return BigInteger_Parse_Z721C83C5(s);
}

export function fromZero(): BigInteger {
    return BigInteger_get_Zero();
}

export function fromOne(): BigInteger {
    return BigInteger_get_One();
}

export function fromInt64(i: int64): BigInteger {
    return BigInteger_$ctor_Z524259C1(i);
}

export function fromInt32(i: int32): BigInteger {
    if (i > 2147483647) {
        return BigInteger_$ctor_Z524259C1(fromInteger(i, false, 6));
    }
    else {
        return BigInteger_$ctor_Z524259A4(i);
    }
}

export function toSByte(x: BigInteger): int8 {
    return BigInteger__get_ToSByte(x);
}

export function toByte(x: BigInteger): uint8 {
    return BigInteger__get_ToByte(x);
}

export function toInt16(x: BigInteger): int16 {
    return BigInteger__get_ToInt16(x);
}

export function toUInt16(x: BigInteger): uint16 {
    return BigInteger__get_ToUInt16(x);
}

export function toInt32(x: BigInteger): int32 {
    return BigInteger__get_ToInt32(x);
}

export function toUInt32(x: BigInteger): uint32 {
    return BigInteger__get_ToUInt32(x);
}

export function toInt64(x: BigInteger): int64 {
    return BigInteger__get_ToInt64(x);
}

export function toUInt64(x: BigInteger): uint64 {
    return BigInteger__get_ToUInt64(x);
}

export function toSingle(x: BigInteger): float32 {
    return BigInteger__get_ToSingle(x);
}

export function toDouble(x: BigInteger): float64 {
    return BigInteger__get_ToDouble(x);
}

export function toDecimal(x: BigInteger): decimal {
    return BigInteger__get_ToDecimal(x);
}

export function sign(x: BigInteger): int32 {
    return BigInteger__get_Sign(x);
}

export function isZero(x: BigInteger): boolean {
    return BigInteger__get_IsZero(x);
}

export function isOne(x: BigInteger): boolean {
    return BigInteger__get_IsOne(x);
}

export function hash(x: BigInteger): int32 {
    return safeHash(x);
}

export function compare(x: BigInteger, y: BigInteger): int32 {
    return x.CompareTo(y);
}

export function equals(x: BigInteger, y: BigInteger): boolean {
    return equals_1(x, y);
}

export function toString(x: BigInteger): string {
    return toString_1(x);
}

export const get_Zero = BigInteger_get_Zero();

export const get_One = BigInteger_get_One();

export function op_Addition(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_Addition_56F059C0(arg, arg_1);
}

export function op_Subtraction(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_Subtraction_56F059C0(arg, arg_1);
}

export function op_Multiply(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_Multiply_56F059C0(arg, arg_1);
}

export function op_Division(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_Division_56F059C0(arg, arg_1);
}

export function op_Modulus(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_Modulus_56F059C0(arg, arg_1);
}

export function op_UnaryNegation(arg: BigInteger): BigInteger {
    return BigInteger_op_UnaryNegation_Z665282C2(arg);
}

export function op_UnaryPlus(arg: BigInteger): BigInteger {
    return BigInteger_op_UnaryPlus_Z665282C2(arg);
}

export function op_RightShift(arg: BigInteger, arg_1: int32): BigInteger {
    return BigInteger_op_RightShift_62E082A2(arg, arg_1);
}

export function op_LeftShift(arg: BigInteger, arg_1: int32): BigInteger {
    return BigInteger_op_LeftShift_62E082A2(arg, arg_1);
}

export function op_BitwiseAnd(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_BitwiseAnd_56F059C0(arg, arg_1);
}

export function op_BitwiseOr(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_BitwiseOr_56F059C0(arg, arg_1);
}

export function op_ExclusiveOr(arg: BigInteger, arg_1: BigInteger): BigInteger {
    return BigInteger_op_ExclusiveOr_56F059C0(arg, arg_1);
}

export function op_LessThan(arg: BigInteger, arg_1: BigInteger): boolean {
    return BigInteger_op_LessThan_56F059C0(arg, arg_1);
}

export function op_LessThanOrEqual(arg: BigInteger, arg_1: BigInteger): boolean {
    return BigInteger_op_LessThanOrEqual_56F059C0(arg, arg_1);
}

export function op_GreaterThan(arg: BigInteger, arg_1: BigInteger): boolean {
    return BigInteger_op_GreaterThan_56F059C0(arg, arg_1);
}

export function op_GreaterThanOrEqual(arg: BigInteger, arg_1: BigInteger): boolean {
    return BigInteger_op_GreaterThanOrEqual_56F059C0(arg, arg_1);
}

export function op_Equality(arg: BigInteger, arg_1: BigInteger): boolean {
    return BigInteger_op_Equality_56F059C0(arg, arg_1);
}

export function op_Inequality(arg: BigInteger, arg_1: BigInteger): boolean {
    return BigInteger_op_Inequality_56F059C0(arg, arg_1);
}

function flipTwosComplement(currByte: uint8, lowBitFound: boolean): [uint8, boolean] {
    if (lowBitFound) {
        return [(currByte ^ 255) & 255, true];
    }
    else if (currByte === 0) {
        return [0, false];
    }
    else {
        return [(currByte ^ (254 << find((i: int32): boolean => ((currByte & (1 << i)) > 0), [0, 1, 2, 3, 4, 5, 6, 7]))) & 255, true];
    }
}

export function toByteArray(value: BigInteger): uint8[] {
    if (equals_1(value, zero)) {
        return [0];
    }
    else {
        const isPositive: boolean = compare_1(value, zero) > 0;
        const value_1: BigInteger = isPositive ? value : BigInteger_op_Multiply_56F059C0(BigInteger_$ctor_Z524259A4(-1), value);
        const mask32: BigInteger = fromInt64(fromInteger(4294967295, false, 6));
        const loop: (arg0: FSharpList<uint8>, arg1: BigInteger, arg2: boolean) => uint8[] = (accumBytes_mut: FSharpList<uint8>, consumeValue_mut: BigInteger, lowBitFound_mut: boolean): uint8[] => {
            let value_6: uint32, value_8: uint32, value_9: uint32, value_10: uint32;
            loop:
            while (true) {
                const accumBytes: FSharpList<uint8> = accumBytes_mut, consumeValue: BigInteger = consumeValue_mut, lowBitFound: boolean = lowBitFound_mut;
                if (compare_1(consumeValue, zero) <= 0) {
                    const accumBytes_1: FSharpList<uint8> = isPositive ? skipWhile((b: uint8): boolean => (b === 0), accumBytes) : skipWhile((b_1: uint8): boolean => (b_1 === 255), accumBytes);
                    const isHighBitOne: boolean = (head(accumBytes_1) & 128) !== 0;
                    return reverse(toArray((isPositive && isHighBitOne) ? cons(0, accumBytes_1) : (((!isPositive) && (!isHighBitOne)) ? cons(255, accumBytes_1) : accumBytes_1)));
                }
                else {
                    const currValue: uint32 = toUInt32(BigInteger_op_BitwiseAnd_56F059C0(consumeValue, mask32));
                    if (isPositive) {
                        const b0: uint8 = currValue & 0xFF;
                        let b1: uint8;
                        const value_4: uint32 = currValue >>> 8;
                        b1 = (value_4 & 0xFF);
                        let b2: uint8;
                        const value_5: uint32 = currValue >>> 16;
                        b2 = (value_5 & 0xFF);
                        accumBytes_mut = ofArrayWithTail([(value_6 = (currValue >>> 24), value_6 & 0xFF), b2, b1, b0], accumBytes);
                        consumeValue_mut = BigInteger_op_RightShift_62E082A2(consumeValue, 32);
                        lowBitFound_mut = false;
                        continue loop;
                    }
                    else {
                        const patternInput: [uint8, boolean] = flipTwosComplement(currValue & 0xFF, lowBitFound);
                        const patternInput_1: [uint8, boolean] = flipTwosComplement((value_8 = (currValue >>> 8), value_8 & 0xFF), patternInput[1]);
                        const patternInput_2: [uint8, boolean] = flipTwosComplement((value_9 = (currValue >>> 16), value_9 & 0xFF), patternInput_1[1]);
                        const patternInput_3: [uint8, boolean] = flipTwosComplement((value_10 = (currValue >>> 24), value_10 & 0xFF), patternInput_2[1]);
                        accumBytes_mut = ofArrayWithTail([patternInput_3[0], patternInput_2[0], patternInput_1[0], patternInput[0]], accumBytes);
                        consumeValue_mut = BigInteger_op_RightShift_62E082A2(consumeValue, 32);
                        lowBitFound_mut = patternInput_3[1];
                        continue loop;
                    }
                }
                break;
            }
        };
        return loop(empty<uint8>(), value_1, false);
    }
}

export function fromByteArray(bytes: uint8[]): BigInteger {
    if (bytes == null) {
        throw new Error("bytes");
    }
    if (bytes.length === 0) {
        return zero;
    }
    else {
        const isPositive: boolean = (bytes[bytes.length - 1] & 128) === 0;
        const buffer: uint8[] = fill(new Array(4), 0, 4, 0);
        const loop: (arg0: FSharpList<uint32>, arg1: int32, arg2: int32, arg3: boolean) => BigInteger = (accumUInt32_mut: FSharpList<uint32>, currIndex_mut: int32, bytesRemaining_mut: int32, lowBitFound_mut: boolean): BigInteger => {
            loop:
            while (true) {
                const accumUInt32: FSharpList<uint32> = accumUInt32_mut, currIndex: int32 = currIndex_mut, bytesRemaining: int32 = bytesRemaining_mut, lowBitFound: boolean = lowBitFound_mut;
                if (bytesRemaining === 0) {
                    const value_2: BigInteger = fold((acc: BigInteger, value: uint32): BigInteger => BigInteger_op_Addition_56F059C0(BigInteger_op_LeftShift_62E082A2(acc, 32), fromInt64(fromInteger(value, false, 6))), zero, accumUInt32);
                    if (isPositive) {
                        return value_2;
                    }
                    else {
                        return BigInteger_op_Multiply_56F059C0(BigInteger_$ctor_Z524259A4(-1), value_2);
                    }
                }
                else {
                    const bytesToProcess: int32 = min(comparePrimitives, bytesRemaining, 4) | 0;
                    for (let i_1: int32 = 0; i_1 <= (bytesToProcess - 1); i_1++) {
                        buffer[i_1] = bytes[currIndex + i_1];
                    }
                    if (isPositive) {
                        fill(buffer, bytesToProcess, 4 - bytesToProcess, 0);
                        accumUInt32_mut = cons((((((buffer[0] | ((buffer[1] << 8) >>> 0)) >>> 0) | ((buffer[2] << 16) >>> 0)) >>> 0) | ((buffer[3] << 24) >>> 0)) >>> 0, accumUInt32);
                        currIndex_mut = (currIndex + bytesToProcess);
                        bytesRemaining_mut = (bytesRemaining - bytesToProcess);
                        lowBitFound_mut = false;
                        continue loop;
                    }
                    else {
                        fill(buffer, bytesToProcess, 4 - bytesToProcess, 255);
                        const patternInput: [uint8, boolean] = flipTwosComplement(buffer[0], lowBitFound);
                        const patternInput_1: [uint8, boolean] = flipTwosComplement(buffer[1], patternInput[1]);
                        const patternInput_2: [uint8, boolean] = flipTwosComplement(buffer[2], patternInput_1[1]);
                        const patternInput_3: [uint8, boolean] = flipTwosComplement(buffer[3], patternInput_2[1]);
                        accumUInt32_mut = cons((((((patternInput[0] | ((patternInput_1[0] << 8) >>> 0)) >>> 0) | ((patternInput_2[0] << 16) >>> 0)) >>> 0) | ((patternInput_3[0] << 24) >>> 0)) >>> 0, accumUInt32);
                        currIndex_mut = (currIndex + bytesToProcess);
                        bytesRemaining_mut = (bytesRemaining - bytesToProcess);
                        lowBitFound_mut = patternInput_3[1];
                        continue loop;
                    }
                }
                break;
            }
        };
        return loop(empty<uint32>(), 0, bytes.length, false);
    }
}

