import { Union } from "./Types.js";
import { union_type, TypeInfo } from "./Reflection.js";
import { Option, some } from "./Option.js";

export const enum FSharpResult$2_Tag {
    Ok = 0,
    Error = 1
}

export type FSharpResult$2_Fields<T, TError> = [[T], [TError]];

export type FSharpResult$2<T, TError> = FSharpResult$2_Cons<T, TError, FSharpResult$2_Tag.Ok> | FSharpResult$2_Cons<T, TError, FSharpResult$2_Tag.Error>;

export function FSharpResult$2_Ok<T, TError>(ResultValue: T) {
    return new FSharpResult$2_Cons<T, TError, FSharpResult$2_Tag.Ok>(FSharpResult$2_Tag.Ok, [ResultValue]);
}

export function FSharpResult$2_Error<T, TError>(ErrorValue: TError) {
    return new FSharpResult$2_Cons<T, TError, FSharpResult$2_Tag.Error>(FSharpResult$2_Tag.Error, [ErrorValue]);
}

export class FSharpResult$2_Cons<T, TError, Tag extends keyof FSharpResult$2_Fields<T, TError>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpResult$2_Fields<T, TError>[Tag]) {
        super();
    }
    cases() {
        return ["Ok", "Error"];
    }
}

export function FSharpResult$2$reflection(gen0: TypeInfo, gen1: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpResult`2", [gen0, gen1], FSharpResult$2_Cons, () => [[["ResultValue", gen0]], [["ErrorValue", gen1]]]);
}

export function Result_Map<a, b, c>(mapping: (arg0: a) => b, result: FSharpResult$2<a, c>): FSharpResult$2<b, c> {
    if (result.tag === FSharpResult$2_Tag.Ok) {
        return FSharpResult$2_Ok<b, c>(mapping(result.fields[0]));
    }
    else {
        return FSharpResult$2_Error<b, c>(result.fields[0]);
    }
}

export function Result_MapError<a, b, c>(mapping: (arg0: a) => b, result: FSharpResult$2<c, a>): FSharpResult$2<c, b> {
    if (result.tag === FSharpResult$2_Tag.Ok) {
        return FSharpResult$2_Ok<c, b>(result.fields[0]);
    }
    else {
        return FSharpResult$2_Error<c, b>(mapping(result.fields[0]));
    }
}

export function Result_Bind<a, b, c>(binder: (arg0: a) => FSharpResult$2<b, c>, result: FSharpResult$2<a, c>): FSharpResult$2<b, c> {
    if (result.tag === FSharpResult$2_Tag.Ok) {
        return binder(result.fields[0]);
    }
    else {
        return FSharpResult$2_Error<b, c>(result.fields[0]);
    }
}

export const enum FSharpChoice$2_Tag {
    Choice1Of2 = 0,
    Choice2Of2 = 1
}

export type FSharpChoice$2_Fields<T1, T2> = [[T1], [T2]];

export type FSharpChoice$2<T1, T2> = FSharpChoice$2_Cons<T1, T2, FSharpChoice$2_Tag.Choice1Of2> | FSharpChoice$2_Cons<T1, T2, FSharpChoice$2_Tag.Choice2Of2>;

export function FSharpChoice$2_Choice1Of2<T1, T2>(Item: T1) {
    return new FSharpChoice$2_Cons<T1, T2, FSharpChoice$2_Tag.Choice1Of2>(FSharpChoice$2_Tag.Choice1Of2, [Item]);
}

export function FSharpChoice$2_Choice2Of2<T1, T2>(Item: T2) {
    return new FSharpChoice$2_Cons<T1, T2, FSharpChoice$2_Tag.Choice2Of2>(FSharpChoice$2_Tag.Choice2Of2, [Item]);
}

export class FSharpChoice$2_Cons<T1, T2, Tag extends keyof FSharpChoice$2_Fields<T1, T2>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpChoice$2_Fields<T1, T2>[Tag]) {
        super();
    }
    cases() {
        return ["Choice1Of2", "Choice2Of2"];
    }
}

export function FSharpChoice$2$reflection(gen0: TypeInfo, gen1: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpChoice`2", [gen0, gen1], FSharpChoice$2_Cons, () => [[["Item", gen0]], [["Item", gen1]]]);
}

export const enum FSharpChoice$3_Tag {
    Choice1Of3 = 0,
    Choice2Of3 = 1,
    Choice3Of3 = 2
}

export type FSharpChoice$3_Fields<T1, T2, T3> = [[T1], [T2], [T3]];

export type FSharpChoice$3<T1, T2, T3> = FSharpChoice$3_Cons<T1, T2, T3, FSharpChoice$3_Tag.Choice1Of3> | FSharpChoice$3_Cons<T1, T2, T3, FSharpChoice$3_Tag.Choice2Of3> | FSharpChoice$3_Cons<T1, T2, T3, FSharpChoice$3_Tag.Choice3Of3>;

export function FSharpChoice$3_Choice1Of3<T1, T2, T3>(Item: T1) {
    return new FSharpChoice$3_Cons<T1, T2, T3, FSharpChoice$3_Tag.Choice1Of3>(FSharpChoice$3_Tag.Choice1Of3, [Item]);
}

export function FSharpChoice$3_Choice2Of3<T1, T2, T3>(Item: T2) {
    return new FSharpChoice$3_Cons<T1, T2, T3, FSharpChoice$3_Tag.Choice2Of3>(FSharpChoice$3_Tag.Choice2Of3, [Item]);
}

export function FSharpChoice$3_Choice3Of3<T1, T2, T3>(Item: T3) {
    return new FSharpChoice$3_Cons<T1, T2, T3, FSharpChoice$3_Tag.Choice3Of3>(FSharpChoice$3_Tag.Choice3Of3, [Item]);
}

export class FSharpChoice$3_Cons<T1, T2, T3, Tag extends keyof FSharpChoice$3_Fields<T1, T2, T3>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpChoice$3_Fields<T1, T2, T3>[Tag]) {
        super();
    }
    cases() {
        return ["Choice1Of3", "Choice2Of3", "Choice3Of3"];
    }
}

export function FSharpChoice$3$reflection(gen0: TypeInfo, gen1: TypeInfo, gen2: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpChoice`3", [gen0, gen1, gen2], FSharpChoice$3_Cons, () => [[["Item", gen0]], [["Item", gen1]], [["Item", gen2]]]);
}

export const enum FSharpChoice$4_Tag {
    Choice1Of4 = 0,
    Choice2Of4 = 1,
    Choice3Of4 = 2,
    Choice4Of4 = 3
}

export type FSharpChoice$4_Fields<T1, T2, T3, T4> = [[T1], [T2], [T3], [T4]];

export type FSharpChoice$4<T1, T2, T3, T4> = FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice1Of4> | FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice2Of4> | FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice3Of4> | FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice4Of4>;

export function FSharpChoice$4_Choice1Of4<T1, T2, T3, T4>(Item: T1) {
    return new FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice1Of4>(FSharpChoice$4_Tag.Choice1Of4, [Item]);
}

export function FSharpChoice$4_Choice2Of4<T1, T2, T3, T4>(Item: T2) {
    return new FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice2Of4>(FSharpChoice$4_Tag.Choice2Of4, [Item]);
}

export function FSharpChoice$4_Choice3Of4<T1, T2, T3, T4>(Item: T3) {
    return new FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice3Of4>(FSharpChoice$4_Tag.Choice3Of4, [Item]);
}

export function FSharpChoice$4_Choice4Of4<T1, T2, T3, T4>(Item: T4) {
    return new FSharpChoice$4_Cons<T1, T2, T3, T4, FSharpChoice$4_Tag.Choice4Of4>(FSharpChoice$4_Tag.Choice4Of4, [Item]);
}

export class FSharpChoice$4_Cons<T1, T2, T3, T4, Tag extends keyof FSharpChoice$4_Fields<T1, T2, T3, T4>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpChoice$4_Fields<T1, T2, T3, T4>[Tag]) {
        super();
    }
    cases() {
        return ["Choice1Of4", "Choice2Of4", "Choice3Of4", "Choice4Of4"];
    }
}

export function FSharpChoice$4$reflection(gen0: TypeInfo, gen1: TypeInfo, gen2: TypeInfo, gen3: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpChoice`4", [gen0, gen1, gen2, gen3], FSharpChoice$4_Cons, () => [[["Item", gen0]], [["Item", gen1]], [["Item", gen2]], [["Item", gen3]]]);
}

export const enum FSharpChoice$5_Tag {
    Choice1Of5 = 0,
    Choice2Of5 = 1,
    Choice3Of5 = 2,
    Choice4Of5 = 3,
    Choice5Of5 = 4
}

export type FSharpChoice$5_Fields<T1, T2, T3, T4, T5> = [[T1], [T2], [T3], [T4], [T5]];

export type FSharpChoice$5<T1, T2, T3, T4, T5> = FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice1Of5> | FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice2Of5> | FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice3Of5> | FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice4Of5> | FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice5Of5>;

export function FSharpChoice$5_Choice1Of5<T1, T2, T3, T4, T5>(Item: T1) {
    return new FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice1Of5>(FSharpChoice$5_Tag.Choice1Of5, [Item]);
}

export function FSharpChoice$5_Choice2Of5<T1, T2, T3, T4, T5>(Item: T2) {
    return new FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice2Of5>(FSharpChoice$5_Tag.Choice2Of5, [Item]);
}

export function FSharpChoice$5_Choice3Of5<T1, T2, T3, T4, T5>(Item: T3) {
    return new FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice3Of5>(FSharpChoice$5_Tag.Choice3Of5, [Item]);
}

export function FSharpChoice$5_Choice4Of5<T1, T2, T3, T4, T5>(Item: T4) {
    return new FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice4Of5>(FSharpChoice$5_Tag.Choice4Of5, [Item]);
}

export function FSharpChoice$5_Choice5Of5<T1, T2, T3, T4, T5>(Item: T5) {
    return new FSharpChoice$5_Cons<T1, T2, T3, T4, T5, FSharpChoice$5_Tag.Choice5Of5>(FSharpChoice$5_Tag.Choice5Of5, [Item]);
}

export class FSharpChoice$5_Cons<T1, T2, T3, T4, T5, Tag extends keyof FSharpChoice$5_Fields<T1, T2, T3, T4, T5>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpChoice$5_Fields<T1, T2, T3, T4, T5>[Tag]) {
        super();
    }
    cases() {
        return ["Choice1Of5", "Choice2Of5", "Choice3Of5", "Choice4Of5", "Choice5Of5"];
    }
}

export function FSharpChoice$5$reflection(gen0: TypeInfo, gen1: TypeInfo, gen2: TypeInfo, gen3: TypeInfo, gen4: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpChoice`5", [gen0, gen1, gen2, gen3, gen4], FSharpChoice$5_Cons, () => [[["Item", gen0]], [["Item", gen1]], [["Item", gen2]], [["Item", gen3]], [["Item", gen4]]]);
}

export const enum FSharpChoice$6_Tag {
    Choice1Of6 = 0,
    Choice2Of6 = 1,
    Choice3Of6 = 2,
    Choice4Of6 = 3,
    Choice5Of6 = 4,
    Choice6Of6 = 5
}

export type FSharpChoice$6_Fields<T1, T2, T3, T4, T5, T6> = [[T1], [T2], [T3], [T4], [T5], [T6]];

export type FSharpChoice$6<T1, T2, T3, T4, T5, T6> = FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice1Of6> | FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice2Of6> | FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice3Of6> | FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice4Of6> | FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice5Of6> | FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice6Of6>;

export function FSharpChoice$6_Choice1Of6<T1, T2, T3, T4, T5, T6>(Item: T1) {
    return new FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice1Of6>(FSharpChoice$6_Tag.Choice1Of6, [Item]);
}

export function FSharpChoice$6_Choice2Of6<T1, T2, T3, T4, T5, T6>(Item: T2) {
    return new FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice2Of6>(FSharpChoice$6_Tag.Choice2Of6, [Item]);
}

export function FSharpChoice$6_Choice3Of6<T1, T2, T3, T4, T5, T6>(Item: T3) {
    return new FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice3Of6>(FSharpChoice$6_Tag.Choice3Of6, [Item]);
}

export function FSharpChoice$6_Choice4Of6<T1, T2, T3, T4, T5, T6>(Item: T4) {
    return new FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice4Of6>(FSharpChoice$6_Tag.Choice4Of6, [Item]);
}

export function FSharpChoice$6_Choice5Of6<T1, T2, T3, T4, T5, T6>(Item: T5) {
    return new FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice5Of6>(FSharpChoice$6_Tag.Choice5Of6, [Item]);
}

export function FSharpChoice$6_Choice6Of6<T1, T2, T3, T4, T5, T6>(Item: T6) {
    return new FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, FSharpChoice$6_Tag.Choice6Of6>(FSharpChoice$6_Tag.Choice6Of6, [Item]);
}

export class FSharpChoice$6_Cons<T1, T2, T3, T4, T5, T6, Tag extends keyof FSharpChoice$6_Fields<T1, T2, T3, T4, T5, T6>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpChoice$6_Fields<T1, T2, T3, T4, T5, T6>[Tag]) {
        super();
    }
    cases() {
        return ["Choice1Of6", "Choice2Of6", "Choice3Of6", "Choice4Of6", "Choice5Of6", "Choice6Of6"];
    }
}

export function FSharpChoice$6$reflection(gen0: TypeInfo, gen1: TypeInfo, gen2: TypeInfo, gen3: TypeInfo, gen4: TypeInfo, gen5: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpChoice`6", [gen0, gen1, gen2, gen3, gen4, gen5], FSharpChoice$6_Cons, () => [[["Item", gen0]], [["Item", gen1]], [["Item", gen2]], [["Item", gen3]], [["Item", gen4]], [["Item", gen5]]]);
}

export const enum FSharpChoice$7_Tag {
    Choice1Of7 = 0,
    Choice2Of7 = 1,
    Choice3Of7 = 2,
    Choice4Of7 = 3,
    Choice5Of7 = 4,
    Choice6Of7 = 5,
    Choice7Of7 = 6
}

export type FSharpChoice$7_Fields<T1, T2, T3, T4, T5, T6, T7> = [[T1], [T2], [T3], [T4], [T5], [T6], [T7]];

export type FSharpChoice$7<T1, T2, T3, T4, T5, T6, T7> = FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice1Of7> | FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice2Of7> | FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice3Of7> | FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice4Of7> | FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice5Of7> | FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice6Of7> | FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice7Of7>;

export function FSharpChoice$7_Choice1Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T1) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice1Of7>(FSharpChoice$7_Tag.Choice1Of7, [Item]);
}

export function FSharpChoice$7_Choice2Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T2) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice2Of7>(FSharpChoice$7_Tag.Choice2Of7, [Item]);
}

export function FSharpChoice$7_Choice3Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T3) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice3Of7>(FSharpChoice$7_Tag.Choice3Of7, [Item]);
}

export function FSharpChoice$7_Choice4Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T4) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice4Of7>(FSharpChoice$7_Tag.Choice4Of7, [Item]);
}

export function FSharpChoice$7_Choice5Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T5) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice5Of7>(FSharpChoice$7_Tag.Choice5Of7, [Item]);
}

export function FSharpChoice$7_Choice6Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T6) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice6Of7>(FSharpChoice$7_Tag.Choice6Of7, [Item]);
}

export function FSharpChoice$7_Choice7Of7<T1, T2, T3, T4, T5, T6, T7>(Item: T7) {
    return new FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, FSharpChoice$7_Tag.Choice7Of7>(FSharpChoice$7_Tag.Choice7Of7, [Item]);
}

export class FSharpChoice$7_Cons<T1, T2, T3, T4, T5, T6, T7, Tag extends keyof FSharpChoice$7_Fields<T1, T2, T3, T4, T5, T6, T7>> extends Union {
    constructor(readonly tag: Tag, readonly fields: FSharpChoice$7_Fields<T1, T2, T3, T4, T5, T6, T7>[Tag]) {
        super();
    }
    cases() {
        return ["Choice1Of7", "Choice2Of7", "Choice3Of7", "Choice4Of7", "Choice5Of7", "Choice6Of7", "Choice7Of7"];
    }
}

export function FSharpChoice$7$reflection(gen0: TypeInfo, gen1: TypeInfo, gen2: TypeInfo, gen3: TypeInfo, gen4: TypeInfo, gen5: TypeInfo, gen6: TypeInfo): TypeInfo {
    return union_type("FSharp.Core.FSharpChoice`7", [gen0, gen1, gen2, gen3, gen4, gen5, gen6], FSharpChoice$7_Cons, () => [[["Item", gen0]], [["Item", gen1]], [["Item", gen2]], [["Item", gen3]], [["Item", gen4]], [["Item", gen5]], [["Item", gen6]]]);
}

export function Choice_makeChoice1Of2<T1, a>(x: T1): FSharpChoice$2<T1, a> {
    return FSharpChoice$2_Choice1Of2<T1, a>(x);
}

export function Choice_makeChoice2Of2<T2, a>(x: T2): FSharpChoice$2<a, T2> {
    return FSharpChoice$2_Choice2Of2<a, T2>(x);
}

export function Choice_tryValueIfChoice1Of2<T1, T2>(x: FSharpChoice$2<T1, T2>): Option<T1> {
    if (x.tag === FSharpChoice$2_Tag.Choice1Of2) {
        return some(x.fields[0]);
    }
    else {
        return void 0;
    }
}

export function Choice_tryValueIfChoice2Of2<T1, T2>(x: FSharpChoice$2<T1, T2>): Option<T2> {
    if (x.tag === FSharpChoice$2_Tag.Choice2Of2) {
        return some(x.fields[0]);
    }
    else {
        return void 0;
    }
}

